#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "fire.h"

int main(int argc,char **argv) {
    struct user_args args;
    struct forest *burning_forest;
    struct forest *next_burning_forest;
    struct drand48_data rand_buffer;

    args = get_user_args(argc,argv);
    srand48_r((time(NULL)+getpid()), &rand_buffer);

    /* These two calls to init_forest initialize the forests we will use for computing values for the upcoming timestep
       (in next_burning_forest) and to hold the currently calculated values. */
    if((burning_forest = init_forest(args,&rand_buffer, 0)) == NULL) {
        fprintf(stderr,"Forest initialization failed\n");
        abort();
    }
    if((next_burning_forest = init_forest(args,&rand_buffer, 1)) == NULL) {
        fprintf(stderr,"Next forest initialization failed\n");
        abort();
    }

    /* This call starts the burning of the trees. */
    if((burn_trees(args,burning_forest,next_burning_forest,&rand_buffer)) < 0) {
        fprintf(stderr,"Burning forest failed\n");
        exit(EXIT_FAILURE);
    }

    free(next_burning_forest);
    free(burning_forest);
    exit(EXIT_SUCCESS);
}
